# Contributor: Erik Larsson <who+alpine@cnackers.org>
# Contributor: Alexander Sack <asac@pantacor.com>
# Maintainer: Alexander Sack <asac@pantacor.com>
pkgname=tpm2-tss
pkgver=3.0.3
pkgrel=1
pkgdesc="TPM 2.0 TSS"
url="https://github.com/tpm2-software/tpm2-tss/"
arch="all"
license="BSD-2-Clause"
makedepends="automake autoconf libtool openssl-dev doxygen perl
	linux-headers cmocka-dev autoconf-archive libgcrypt-dev
	json-c-dev curl-dev"
subpackages="
	$pkgname-doc
	$pkgname-mu
	$pkgname-sys
	$pkgname-esys
	$pkgname-tcti-device
	$pkgname-tcti-mssim
	$pkgname-tcti-swtpm
	$pkgname-tcti-cmd
	$pkgname-rc
	$pkgname-tctildr
	$pkgname-fapi
	$pkgname-static
	$pkgname-dev
	"
source="
	$pkgname-$pkgver.tar.gz::https://github.com/tpm2-software/tpm2-tss/archive/$pkgver.tar.gz

	disable_tctildr-dl_test.patch
	autoconf-2.71-disable-integration.patch
	tpm2-tss_audit_trail_callback.patch
"

prepare() {
	default_prepare
	./bootstrap
}

build() {
	./configure \
		--build=$CBUILD \
		--host=$CHOST \
		--prefix=/usr \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--without-udevrulesdir \
		--with-tctidefaultmodule=device \
		--with-tctidefaultconfig=/dev/tpmrm0 \
		--with-crypto=ossl \
		--enable-unit
	make
}

check() {
	make check
}

package() {
	make DESTDIR="$pkgdir" install
	rm -rf "$pkgdir"/etc/tmpfiles.d
	rm -rf "$pkgdir"/etc/sysusers.d
}

mu() {
	pkgdesc="TPM 2.0 Marshaling libraries"
	mkdir -p "$subpkgdir"/usr/lib
	mv "$pkgdir"/usr/lib/libtss2-mu.so.* "$subpkgdir"/usr/lib
}

sys() {
	pkgdesc="TPM 2.0 System API libraries"
	mkdir -p "$subpkgdir"/usr/lib
	mv "$pkgdir"/usr/lib/libtss2-sys.so.* "$subpkgdir"/usr/lib
}

esys() {
	pkgdesc="TPM 2.0 Enhanced System API libraries"
	mkdir -p "$subpkgdir"/usr/lib
	mv "$pkgdir"/usr/lib/libtss2-esys.so.* "$subpkgdir"/usr/lib
}

device() {
	pkgdesc="TPM 2.0 Device TCTI"
	provides="libtss2-tcti"
	provider_priority="100"
	mkdir -p "$subpkgdir"/usr/lib
	mv "$pkgdir"/usr/lib/libtss2-tcti-device.so.* "$subpkgdir"/usr/lib
}

mssim() {
	pkgdesc="TPM 2.0 Simulator TCTI"
	provides="libtss2-tcti"
	provider_priority="10"
	mkdir -p "$subpkgdir"/usr/lib
	mv "$pkgdir"/usr/lib/libtss2-tcti-mssim.so.* "$subpkgdir"/usr/lib
}

rc() {
	pkgdesc="TPM 2.0 RC libraries"
	mkdir -p "$subpkgdir"/usr/lib
	mv "$pkgdir"/usr/lib/libtss2-rc.so.* "$subpkgdir"/usr/lib
}

tctildr() {
	pkgdesc="TPM 2.0 TCTI loader libraries"
	mkdir -p "$subpkgdir"/usr/lib
	mv "$pkgdir"/usr/lib/libtss2-tctildr.so.* "$subpkgdir"/usr/lib
}

fapi() {
	pkgdesc="TPM 2.0 FAPI libraries"
	mkdir -p "$subpkgdir"/usr/lib "$subpkgdir"/etc/tpm2-tss
	mv "$pkgdir"/usr/lib/libtss2-fapi.so.* "$subpkgdir"/usr/lib
	mv "$pkgdir"/etc/tpm2-tss/fapi-config.json "$subpkgdir"/etc/tpm2-tss
	mv "$pkgdir"/etc/tpm2-tss/fapi-profiles "$subpkgdir"/etc/tpm2-tss
}

swtpm() {
	pkgdesc="TPM 2.0 SWTPM TCTI"
	provides="libtss2-tcti"
	provider_priority="10"
	mkdir -p "$subpkgdir"/usr/lib
	mv "$pkgdir"/usr/lib/libtss2-tcti-swtpm.so.* "$subpkgdir"/usr/lib
}

cmd() {
	pkgdesc="TPM 2.0 CMD TCTI"
	provides="libtss2-tcti"
	provider_priority="10"
	mkdir -p "$subpkgdir"/usr/lib
	mv "$pkgdir"/usr/lib/libtss2-tcti-cmd.so.* "$subpkgdir"/usr/lib
}

sha512sums="
856038f34e53f29baafb6490fd84a4d5bcc351d9e8aa2bf3d8f081a86185d7675384fee80d69f303842276bb271a8aef20333dd8bd994582b6354696c3289ed4  tpm2-tss-3.0.3.tar.gz
535a24560b3dd8c498b4f87815fc23c39fde9a27e7aa21a51c49dc854bca4bc26a2a0df8b48b557cbe339789f0cdbd2dd341526887a2c03bb1cd2e6af9d7aa9f  disable_tctildr-dl_test.patch
6de7100ad4ee5a53c412a09458d4dda644fe03798e1f1fb7c91e195a6d3856af20d0837ba9227f52516d6fdfeaea7effd97420ed25fb8f9d99f9e8e27dd1f99f  autoconf-2.71-disable-integration.patch
"
